package mk.tmarkovski.android.glasnik;

import mk.tmarkovski.android.glasnik.feed.IFeedFormatter;
import mk.tmarkovski.android.glasnik.feed.formatters.HtmlFormatter;
import mk.tmarkovski.android.glasnik.feed.formatters.KurirFormatter;
import mk.tmarkovski.android.glasnik.feed.formatters.Makedonija24Formatter;
import mk.tmarkovski.android.glasnik.feed.formatters.TimeFormatter;

import java.util.HashMap;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 23.2.12
 * Time: 20:09
 * To change this template use File | Settings | File Templates.
 */
public interface AppConstants {
    public static final String PACKAGE = "mk.tmarkovski.android.glasnik";

    public static final int WIDGET_NEWS_COUNT_PER_CATEGORY = 2;
    public static final float WIDGET_IMAGE_MAX_SIZE = 200;

    public static final String LOG = PACKAGE;

    public static final String FORCE_UPDATE_EXTRA = "mk.tmarkovski.android.FORCE_UPDATE_EXTRA";
    public static final String FEED_CODE_EXTRA = "mk.tmarkovski.android.FEED_CODE_EXTRA";
    public static final String URL_TAG_EXTRA = "mk.tmarkovski.android.URL_TAG_EXTRA";
    public static final String TITLE_TAG_EXTRA = "mk.tmarkovski.android.TITLE_TAG_EXTRA";
    public static final String PROGRESS_EXTRA = "mk.tmarkovski.android.PROGRESS_EXTRA";

    public static final String ACTION_FEED_UPDATE_PROGRESS = "mk.tmarkovski.android.action.UPDATE_PROGRESS";
    public static final String ACTION_FEED_UPDATE = "mk.tmarkovski.android.action.FEED_UPDATE_COMPLETED";
    public static final String ACTION_WEATHER_UPDATE = "mk.tmarkovski.android.action.WEATHER_UPDATE_COMPLETED";
    public static final String ACTION_CURRENCY_UPDATE = "mk.tmarkovski.android.action.CURRENCY_UPDATE_COMPLETED";

    static final String PREF_AUTO_UPDATE = "pref_auto_update";
    static final String PREF_UPDATE_INTERVAL = "pref_update_interval";
    static final String PREF_DOWNLOAD_IMAGES = "pref_download_images";
    static final String PREF_MAX_FEED_COUNT = "pref_max_feed_count";
    static final String PREF_WIDGET_FEED_CODE = "pref_widget_feed_code";

    static final String PREF_LAST_GLOBAL_UPDATE = "pref_last_global_update";

    static final HashMap<String, FeedDefinition> mDefaultFeedCollection = new HashMap<String, FeedDefinition>() {
        {
            put("makedonija24", new FeedDefinition("http://www.makedonija24.mk//search/externalSearch/type/mrss", new Makedonija24Formatter(), "Македонија 24", "utf-8"));
            put("makedonija", new FeedDefinition("http://feeds.feedburner.com/kurir/makedonija?format=xml", new KurirFormatter(), "Македонија", "utf-8"));
            put("svet", new FeedDefinition("http://feeds.feedburner.com/kurir/svet?format=xml", new KurirFormatter(), "Свет", "utf-8"));
            put("republika", new FeedDefinition("http://feeds.feedburner.com/kurir/republika?format=xml", new KurirFormatter(), "Република", "utf-8"));
            put("komentari", new FeedDefinition("http://feeds.feedburner.com/kurir/komentari?format=xml", new KurirFormatter(), "Коментари", "utf-8"));
            put("sport", new FeedDefinition("http://feeds.feedburner.com/kurir/sport?format=xml", new KurirFormatter(), "Спорт", "utf-8"));
            put("magazin", new FeedDefinition("http://feeds.feedburner.com/kurir/magazin?format=xml", new KurirFormatter(), "Магазин", "utf-8"));
            //put("kurir_makedonija", new FeedDefinition("http://feeds.feedburner.com/kurir/makedonija?format=xml", new KurirFormatter(), "Kurir.mk", "utf-8"));
            //put("idividi", new FeedDefinition("http://www.idividi.com.mk/rss.aspx", new HtmlFormatter(), "Идивиди", "cp-1251"));
        }
    };

    class FeedDefinition {
        private String mUrl;
        private IFeedFormatter mFormatter;
        private String mDescription;
        private String mEncoding;

        FeedDefinition(String pUrl, IFeedFormatter pFormatter, String pDescription, String pEncoding) {
            this.mUrl = pUrl;
            this.mFormatter = pFormatter;
            this.mDescription = pDescription;
            this.mEncoding = pEncoding;
        }

        public String getDescription() {
            return mDescription;
        }

        public IFeedFormatter getFormatter() {
            return mFormatter;
        }

        public String getUrl() {
            return mUrl;
        }

        public String getEncoding() {
            return mEncoding;
        }
    }
}
