package mk.tmarkovski.android.glasnik.activity;

import android.content.Context;
import android.graphics.BitmapFactory;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import mk.tmarkovski.android.glasnik.AppConstants;
import mk.tmarkovski.android.glasnik.R;
import mk.tmarkovski.android.glasnik.currency.CurrencyModel;

import java.io.IOException;
import java.text.DecimalFormat;

/**
 * Created by IntelliJ IDEA.
 * User: Tomislav.Markovski
 * Date: 2/28/12
 * Time: 2:54 PM
 * To change this template use File | Settings | File Templates.
 */
public class CurrencyAdapter extends BaseAdapter implements AppConstants {
    private CurrencyModel[] mRates;
    private LayoutInflater mInflater;
    private Context mContext;

    public CurrencyAdapter(Context context, CurrencyModel[] rates) {
        this.mRates = rates;
        this.mInflater = LayoutInflater.from(context);
        this.mContext = context;
    }

    @Override
    public int getCount() {
        return mRates.length;
    }

    @Override
    public Object getItem(int i) {
        return mRates[i];
    }

    @Override
    public long getItemId(int i) {
        return 0;
    }

    @Override
    public View getView(int i, View view, ViewGroup viewGroup) {
        ViewHolder holder;

        if (view == null) {
            view = mInflater.inflate(R.layout.list_entry_currency, null);

            holder = new ViewHolder();
            holder.code = (TextView) view.findViewById(R.id.currCode);
            holder.code_mk = (TextView) view.findViewById(R.id.currCodeMk);
            holder.image = (ImageView) view.findViewById(R.id.currImage);
            holder.rate = (TextView) view.findViewById(R.id.currRate);
            view.setTag(holder);
        } else {
            holder = (ViewHolder) view.getTag();
        }
        holder.code.setText(this.mRates[i].getCurrencyName());
        holder.code_mk.setText(this.mRates[i].getCurrencyName_mk());
        holder.rate.setText(String.valueOf(new DecimalFormat("#.00").format(this.mRates[i].getRate())));
        try {
            holder.image.setImageBitmap(BitmapFactory.decodeStream(
                    view.getContext().getResources().getAssets().open("flag_" + this.mRates[i].getCurrencyName().toLowerCase() + ".png")));
        } catch (IOException e) {
            Log.e(LOG, "Error opening flag file for " + this.mRates[i].getCurrencyName(), e);
        }

        return view;
    }

    class ViewHolder {
        TextView code;
        TextView code_mk;
        ImageView image;
        TextView rate;
    }
}
