package mk.tmarkovski.android.glasnik.activity;

import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.preference.PreferenceScreen;
import android.view.Window;
import mk.tmarkovski.android.glasnik.AppConstants;
import mk.tmarkovski.android.glasnik.R;
import mk.tmarkovski.android.glasnik.updates.AlarmHandler;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 4.2.12
 * Time: 23:29
 * To change this template use File | Settings | File Templates.
 */
public class SettingsActivity extends PreferenceActivity implements AppConstants, SharedPreferences.OnSharedPreferenceChangeListener {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        super.onCreate(savedInstanceState);


        AlarmHandler.updateAlarm(this);

        addPreferencesFromResource(R.xml.preferences);
        setSummary(PREF_UPDATE_INTERVAL);
        setSummary(PREF_MAX_FEED_COUNT);

        //addPreferencesFromIntent();
    }

    public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String s) {
        if (PREF_UPDATE_INTERVAL.equals(s)
                || PREF_MAX_FEED_COUNT.equals(s)) {
            setSummary(s);
        }

        if (PREF_AUTO_UPDATE.equals(s))
            AlarmHandler.updateAlarm(this);

    }

    private void setSummary(String key) {
        String value = null;

        if (PREF_UPDATE_INTERVAL.equals(key)) {
            String[] values = getResources().getStringArray(R.array.updateIntervalValues);
            for (int i = 0; i < values.length; i++) {
                if (values[i].equals(PreferenceManager.getDefaultSharedPreferences(this).getString(key, "60")))
                    value = getResources().getStringArray(R.array.updateInterval)[i];
            }
            AlarmHandler.updateAlarm(this);
        }
        if (PREF_MAX_FEED_COUNT.equals(key)) {
            int count = PreferenceManager.getDefaultSharedPreferences(this).getInt(PREF_MAX_FEED_COUNT, 5);
            value = String.format(getResources().getQuantityString(R.plurals.brojNaVesti, count), count);
        }

        findPreference(key).setSummary(value);
    }

    @Override
    protected void onResume() {
        super.onResume();

        PreferenceManager.getDefaultSharedPreferences(this).registerOnSharedPreferenceChangeListener(this);
    }

    @Override
    protected void onPause() {
        super.onPause();

        PreferenceManager.getDefaultSharedPreferences(this).unregisterOnSharedPreferenceChangeListener(this);
    }
}
