package mk.tmarkovski.android.glasnik.activity;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.Window;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import mk.tmarkovski.android.glasnik.AppConstants;
import mk.tmarkovski.android.glasnik.R;
import mk.tmarkovski.android.glasnik.Utils;
import mk.tmarkovski.android.glasnik.weather.LocationFinder;
import mk.tmarkovski.android.glasnik.weather.WeatherSet;
import mk.tmarkovski.android.glasnik.weather.WeatherUpdater;
import mk.tmarkovski.android.glasnik.weather.WeatherUtils;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 12.2.12
 * Time: 17:39
 * To change this template use File | Settings | File Templates.
 */
public class WeatherActivity extends Activity implements AppConstants {
    private WeatherSet mWeatherSet;
    private BroadcastReceiver mUpdateReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            if (ACTION_WEATHER_UPDATE.equals(intent.getAction())) {
                load();
            }
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        registerReceiver(mUpdateReceiver, new IntentFilter(ACTION_WEATHER_UPDATE));
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        setContentView(R.layout.activity_weather);

        load();
    }

    private void load() {
        mWeatherSet = WeatherUpdater.getWeather(this);
        if (mWeatherSet != null) {
            ((TextView) findViewById(R.id.cityTextView)).setText(new LocationFinder().getCityNameLocal(this));
            ((TextView) findViewById(R.id.conditionTextView)).setText(WeatherUtils.conditionToLocalString(mWeatherSet.getWeatherCurrentCondition().getCondition()));
            ((TextView) findViewById(R.id.temperatureTextView)).setText(mWeatherSet.getWeatherCurrentCondition().getTempCelcius().toString() + "°C");
            ((ImageView) findViewById(R.id.weatherIconImageView)).setImageResource(WeatherUtils.conditionToImage(mWeatherSet.getWeatherCurrentCondition().getCondition(), false));
            findViewById(R.id.conditionContainer).setBackgroundResource(Utils.isNight() ? R.drawable.background_weather_night : R.drawable.background_weather_day);
            ((ListView)findViewById(R.id.forecastListView)).setAdapter(new WeatherForecastAdapter(this, mWeatherSet.getWeatherForecastConditions()));
        }
    }
}
