package mk.tmarkovski.android.glasnik.activity;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import mk.tmarkovski.android.glasnik.R;
import mk.tmarkovski.android.glasnik.weather.WeatherForecastCondition;
import mk.tmarkovski.android.glasnik.weather.WeatherUtils;

import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 26.2.12
 * Time: 22:57
 * To change this template use File | Settings | File Templates.
 */
public class WeatherForecastAdapter extends BaseAdapter {
    private ArrayList<WeatherForecastCondition> mWeatherForecastConditions;
    private LayoutInflater mInflater;

    public WeatherForecastAdapter(Context context, ArrayList<WeatherForecastCondition> weatherForecastConditions) {
        this.mWeatherForecastConditions = weatherForecastConditions;
        mInflater = LayoutInflater.from(context);
    }

    public int getCount() {
        return this.mWeatherForecastConditions.size();
    }

    public Object getItem(int i) {
        return mWeatherForecastConditions.get(i);
    }

    public long getItemId(int i) {
        return 0;
    }

    public View getView(int i, View view, ViewGroup viewGroup) {
        ViewHolder holder;

        if (view == null) {
            view = mInflater.inflate(R.layout.list_entry_weather, null);

            holder = new ViewHolder();
            holder.temperature = (TextView) view.findViewById(R.id.forecastTemperature);
            holder.image = (ImageView) view.findViewById(R.id.forecastImage);
            holder.day = (TextView) view.findViewById(R.id.forecastDay);
            holder.condition = (TextView) view.findViewById(R.id.forecastCondition);

            view.setTag(holder);
        } else {
            holder = (ViewHolder) view.getTag();
        }
        holder.day.setText(getDayOfWeekLocalized(mWeatherForecastConditions.get(i).getDayofWeek()));
        holder.condition.setText(WeatherUtils.conditionToLocalString(mWeatherForecastConditions.get(i).getCondition()));
        holder.temperature.setText(mWeatherForecastConditions.get(i).getTempMinCelsius() + "°C до " +
                mWeatherForecastConditions.get(i).getTempMaxCelsius() + "°C");
        holder.image.setImageResource(WeatherUtils.conditionToImage(mWeatherForecastConditions.get(i).getCondition(), true));

        return view;
    }

    private CharSequence getDayOfWeekLocalized(String dayofWeek) {
        String day = dayofWeek.toLowerCase();
        if ("mon".equals(day)) return "вторник";
        if ("tue".equals(day)) return "среда";
        if ("wed".equals(day)) return "четврток";
        if ("thu".equals(day)) return "петок";
        if ("fri".equals(day)) return "сабота";
        if ("sat".equals(day)) return "недела";
        if ("sun".equals(day)) return "понеделник";
        return dayofWeek;
    }

    class ViewHolder {
        TextView temperature;
        ImageView image;
        TextView day;
        TextView condition;
    }
}
