package mk.tmarkovski.android.glasnik.currency;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 28.2.12
 * Time: 00:25
 * To change this template use File | Settings | File Templates.
 */
public class CurrencyHandler extends DefaultHandler {
    private List<CurrencyModel> mRates;
    private CurrencyModel mModel;

    private boolean inOznaka;
    private boolean inNazivMak;
    private boolean inDrzava;
    private boolean inSreden;
    private boolean inNomin;
    private boolean inDatum;
    private boolean inValuta;

    @Override
    public void startDocument() throws SAXException {
        this.mRates = new ArrayList<CurrencyModel>();
        super.startDocument();
    }

    @Override
    public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
        super.startElement(uri, localName, qName, attributes);

        if ("KursZbir".equals(localName))
            this.mModel = new CurrencyModel();
        else if ("Oznaka".equals(localName))
            this.inOznaka = true;
        else if ("NazivMak".equals(localName))
            this.inNazivMak = true;
        else if ("Drzava".equals(localName))
            this.inDrzava = true;
        else if ("Sreden".equals(localName))
            this.inSreden = true;
        else if ("Nomin".equals(localName))
            this.inNomin = true;
        else if ("Datum".equals(localName))
            this.inDatum = true;
        else if ("Valuta".equals(localName))
            this.inValuta = true;
    }

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException {
        super.endElement(uri, localName, qName);

        if ("KursZbir".equals(localName))
            this.mRates.add(this.mModel);
        else if ("Oznaka".equals(localName))
            this.inOznaka = false;
        else if ("NazivMak".equals(localName))
            this.inNazivMak = false;
        else if ("Drzava".equals(localName))
            this.inDrzava = false;
        else if ("Sreden".equals(localName))
            this.inSreden = false;
        else if ("Nomin".equals(localName))
            this.inNomin = false;
        else if ("Datum".equals(localName))
            this.inDatum = false;
        else if ("Valuta".equals(localName))
            this.inValuta = false;
    }

    @Override
    public void characters(char[] ch, int start, int length) throws SAXException {
        super.characters(ch, start, length);
        String chars = (new String(ch).substring(start, start + length));
        if (inOznaka) this.mModel.setCurrencyName(chars);
        else if (inNazivMak) this.mModel.setCurrencyName_mk(chars);
        else if (inDrzava) this.mModel.setCountryName_mk(chars);
        else if (inSreden) this.mModel.setRate(Float.parseFloat(chars));
        else if (inNomin) this.mModel.setCurrencyUnits(Double.parseDouble(chars));
        else if (inDatum) this.mModel.setDate(new Date());
        else if (inValuta) this.mModel.setCurrencyCode(Double.parseDouble(chars));
    }

    public List<CurrencyModel> getExchangeRates() {
        return mRates;
    }
}
