package mk.tmarkovski.android.glasnik.currency;

import android.text.format.DateFormat;
import android.util.Log;
import mk.tmarkovski.android.glasnik.AppConstants;
import org.ksoap2.SoapEnvelope;
import org.ksoap2.serialization.PropertyInfo;
import org.ksoap2.serialization.SoapObject;
import org.ksoap2.serialization.SoapPrimitive;
import org.ksoap2.serialization.SoapSerializationEnvelope;
import org.ksoap2.transport.HttpTransportSE;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import java.io.StringReader;
import java.util.Date;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: tomislav.markovski
 * Date: 2/24/12
 * Time: 3:25 PM
 * To change this template use File | Settings | File Templates.
 */
public class ExchangeRateWSReader implements AppConstants {
    private static final String NAMESPACE = "http://www.nbrm.mk/klservice/";
    private static final String METHOD_NAME = "GetExchangeRate";
    private static final String SOAP_ACTION = "http://www.nbrm.mk/klservice/GetExchangeRate";
    private static final String URL = "http://www.nbrm.mk/klservice/kurs.asmx";

    public static List<CurrencyModel> get() {
        SoapObject request = new SoapObject(NAMESPACE, METHOD_NAME);
        SoapSerializationEnvelope envelope = new SoapSerializationEnvelope(SoapEnvelope.VER11);
        envelope.dotNet = true;
        envelope.setOutputSoapObject(request);

        String formattedDate = DateFormat.format("dd.MM.yyyy", new Date()).toString();

        PropertyInfo startDate = new PropertyInfo();
        startDate.setName("StartDate");
        startDate.setValue(formattedDate);
        startDate.setType(String.class);
        request.addProperty(startDate);

        PropertyInfo endDate = new PropertyInfo();
        endDate.setName("EndDate");
        endDate.setValue(formattedDate);
        endDate.setType(String.class);
        request.addProperty(endDate);

        HttpTransportSE androidHttpTransport = new HttpTransportSE(URL);
        try {
            androidHttpTransport.call(SOAP_ACTION, envelope);
            SoapPrimitive response = (SoapPrimitive) envelope.getResponse();


            SAXParserFactory spf = SAXParserFactory.newInstance();
            SAXParser sp = spf.newSAXParser();

            XMLReader xr = sp.getXMLReader();

            CurrencyHandler gwh = new CurrencyHandler();
            xr.setContentHandler(gwh);

            //Log.d(LOG, response.toString());
            xr.parse(new InputSource(new StringReader("<?xml version=\"1.0\" encoding=\"utf-8\"?>" + response.toString())));

            return gwh.getExchangeRates();
        } catch (Exception e) {
            Log.e(LOG, "Error getting exchange rate info from web service.", e);
        }

        return null;
    }
}
