package mk.tmarkovski.android.glasnik.updates;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.preference.PreferenceManager;
import mk.tmarkovski.android.glasnik.AppConstants;

import java.util.Calendar;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 6.2.12
 * Time: 22:58
 * To change this template use File | Settings | File Templates.
 */
public class AlarmHandler implements AppConstants {

    public static void updateAlarm(Context context) {

        PendingIntent intent = IntentManager.getPendingIntent(context);
        AlarmManager alarmManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
        alarmManager.cancel(intent);
        if (!isAlarmEnabled(context)) {
            return;
        }

        Calendar cal = Calendar.getInstance();
        cal.add(Calendar.SECOND, 10);

        alarmManager.setRepeating(android.app.AlarmManager.RTC, cal.getTimeInMillis(), 10000, intent);
    }

    public static boolean isAlarmEnabled(Context context) {
        return PreferenceManager.getDefaultSharedPreferences(context)
                .getBoolean(PREF_AUTO_UPDATE, true);
    }

    public static void cancel(Context context) {
        PendingIntent intent = IntentManager.getPendingIntent(context);
        AlarmManager alarmManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
        alarmManager.cancel(intent);
    }
}
