package mk.tmarkovski.android.glasnik.weather;

import android.content.Context;
import android.location.Location;
import android.preference.PreferenceManager;
import mk.tmarkovski.android.glasnik.AppConstants;

import java.util.HashMap;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 27.2.12
 * Time: 01:37
 * To change this template use File | Settings | File Templates.
 */
public class LocationFinder implements AppConstants {
    private HashMap<String, LocationPoint> cityLocationMap = new HashMap<String, LocationPoint>() {
        {
            put("Skopje", new LocationPoint(41.973785, 21.428833, "Скопје"));
            put("Bitola", new LocationPoint(41.004775, 21.390381, "Битола"));
            put("Gevgelija", new LocationPoint(41.145049, 22.506684, "Гевгелија"));
            put("Prilep", new LocationPoint(41.352072, 21.577148, "Прилеп"));
            put("Tetovo", new LocationPoint(41.99216, 20.961914, "Тетово"));
            put("Kumanovo", new LocationPoint(42.13515, 21.724434, "Куманово"));
            put("Kriva Palanka", new LocationPoint(42.213008, 22.336922, "Крива Паланка"));
            put("Ohrid", new LocationPoint(41.121521, 20.810509, "Охрид"));
            put("Berovo", new LocationPoint(41.706497, 22.852592, "Берово"));
        }
    };

    public class LocationPoint {

        double lon;
        double lat;
        private String city;

        public LocationPoint(double latitude, double longitude, String localName) {
            this.lon = longitude;
            this.lat = latitude;
            this.city = localName;
        }

    }

    public String getCityNameLocal(Context context) {
        String selectedLocation = PreferenceManager.getDefaultSharedPreferences(context).getString("weather_location", "Skopje");
        return cityLocationMap.get(selectedLocation).city;
    }

    public String findCurrentCity(Context context) {
        boolean detectLocation = PreferenceManager.getDefaultSharedPreferences(context).getBoolean("weather_detect_location", true);
        String selectedLocation = PreferenceManager.getDefaultSharedPreferences(context).getString("weather_location", "Skopje");
        if (detectLocation) {
            android.location.LocationManager locationManager = (android.location.LocationManager) context.getSystemService(Context.LOCATION_SERVICE);
            if (locationManager.isProviderEnabled(android.location.LocationManager.NETWORK_PROVIDER)) {
                Location location = locationManager.getLastKnownLocation(android.location.LocationManager.NETWORK_PROVIDER);
                selectedLocation = getNearest(location);
            }
        }
        PreferenceManager.getDefaultSharedPreferences(context).edit().putString("weather_location", selectedLocation).commit();
        return selectedLocation + ", Macedonia";
    }

    private String getNearest(Location location) {
        float distance = Float.MAX_VALUE;
        String city = "Skopje";
        //Log.d(LOG, String.format("Finding location for LAT=%s, LON=%s", location.getLatitude(), location.getLongitude()));
        for (String key : cityLocationMap.keySet()) {
            LocationPoint point = cityLocationMap.get(key);
            float[] result = new float[5];
            Location.distanceBetween(point.lat, point.lon, location.getLatitude(), location.getLongitude(), result);
            //Log.d(LOG, "Checking distance between current and " + key + " (LAT=" + point.lat + " LON=" + point.lon + ") = " + result[0] / 1000 + "km");
            if (result[0] < distance) {
                distance = result[0];
                city = key;
                //Log.d(LOG, "Nearest is now " + key);
            }
        }
        return city;
    }
}
