package mk.tmarkovski.android.glasnik.weather;

import android.content.Context;
import android.content.Intent;
import android.util.Log;
import mk.tmarkovski.android.glasnik.AppConstants;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.URL;

/**
 * Created by IntelliJ IDEA.
 * User: Tome
 * Date: 26.2.12
 * Time: 20:17
 * To change this template use File | Settings | File Templates.
 */
public class WeatherUpdater implements AppConstants {
    public static void update(Context context) {
        String queryString = String.format("http://www.google.com/ig/api?weather=%s",
                new LocationFinder().findCurrentCity(context));

        try {
            URL url = new URL(queryString.replace(" ", "%20"));
            FileOutputStream fos = context.openFileOutput("weather", Context.MODE_PRIVATE);
            InputStream inputStream = new InputSource(url.openStream()).getByteStream();

            int current;
            while ((current = inputStream.read()) != -1) {
                fos.write((byte) current);
            }
            fos.close();
            inputStream.close();
            context.sendBroadcast(new Intent(ACTION_WEATHER_UPDATE));

        } catch (Exception e) {
            e.printStackTrace();
            Log.e(LOG, "Error updating the weather", e);
        }
    }

    public static WeatherSet getWeather(Context context) {
        try {
            SAXParserFactory spf = SAXParserFactory.newInstance();
            SAXParser sp = spf.newSAXParser();

            XMLReader xr = sp.getXMLReader();

            GoogleWeatherHandler gwh = new GoogleWeatherHandler();
            xr.setContentHandler(gwh);
            FileInputStream fis = context.openFileInput("weather");
            xr.parse(new InputSource(fis));
            fis.close();
            return gwh.getWeatherSet();

        } catch (Exception e) {
            e.printStackTrace();
            Log.e(LOG, "Error reading weather data from storage", e);
        }
        return null;
    }

}
